--- old/usr/src/uts/common/fs/portfs/port_fop.c	Fri Jan 18 13:59:20 2013
+++ new/usr/src/uts/common/fs/portfs/port_fop.c	Fri Jan 18 13:59:20 2013
@@ -23,6 +23,9 @@
  * Use is subject to license terms.
  */
 
+/*
+ * Copyright (c) 2013, Joyent, Inc. All rights reserved.
+ */
 
 /*
  * File Events Notification
@@ -1965,7 +1968,9 @@
 	if (op & FOP_ATTRIB_MASK) {
 		event  |= FILE_ATTRIB;
 	}
-
+	if (op & FOP_TRUNC_MASK) {
+		event  |= FILE_TRUNC;
+	}
 	if (event) {
 		port_fop_sendevent(vp, 	event, NULL, NULL);
 	}
@@ -2147,6 +2152,9 @@
 	int		events = 0;
 
 	retval = vnext_setattr(vf, vap, flags, cr, ct);
+	if (vap->va_mask & AT_SIZE) {
+		events |= FOP_FILE_TRUNC;
+	}
 	if (vap->va_mask & (AT_SIZE|AT_MTIME)) {
 		events |= FOP_FILE_SETATTR_MTIME;
 	}
@@ -2322,8 +2330,8 @@
 			port_fop_sendevent(vp, FILE_DELETE, dvp, name);
 		break;
 	case	VE_CREATE:
-			port_fop_sendevent(vp, FILE_MODIFIED|FILE_ATTRIB,
-			    NULL, NULL);
+			port_fop_sendevent(vp,
+			    FILE_MODIFIED|FILE_ATTRIB|FILE_TRUNC, NULL, NULL);
 		break;
 	case	VE_LINK:
 			port_fop_sendevent(vp, FILE_ATTRIB, NULL, NULL);
